diff --git a/ChangeLog b/ChangeLog
index f45be8d9..6856c410 100755
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,6 +1,7 @@
 - internal: put output parameters in a single struct
 - Fix GuessDir bug - issue #215
 - Compact Changelog
+- Fix GuessDir bug - issue #215 in flow exporter
 
 2020-03-29
 - Release 1.6.20
diff --git a/bin/nfexport.c b/bin/nfexport.c
index 4cbeff18..a5824e3b 100755
--- a/bin/nfexport.c
+++ b/bin/nfexport.c
@@ -351,12 +351,8 @@ char				*string;
 				ApplyAggrMask(flow_record, aggr_record_mask);
 			}
 
-			if ( GuessDir && 
-			   ( flow_record->prot == IPPROTO_TCP || flow_record->prot == IPPROTO_UDP) &&
-			   ( flow_record->srcport < 1024 ) && ( flow_record->dstport > 1024 ) &&
-			   ( flow_record->srcport < flow_record->dstport ) ) {
+			if ( NeedSwap(GuessDir, flow_record) ) 
 				SwapFlow(flow_record);
-			}
 
 			// switch to output extension map
 			flow_record->map_ref = extension_info->exportMap ? extension_info->exportMap : extension_info->map;
@@ -405,12 +401,8 @@ char				*string;
 					ApplyAggrMask(flow_record, aggr_record_mask);
 				}
 
-				if ( GuessDir && 
-			   	   ( flow_record->prot == IPPROTO_TCP || flow_record->prot == IPPROTO_UDP) &&
-			   	   ( flow_record->srcport < 1024 ) && ( flow_record->dstport > 1024 ) &&
-			   	   ( flow_record->srcport < flow_record->dstport ) ) {
+				if ( NeedSwap(GuessDir, flow_record) )  
 					SwapFlow(flow_record);
-				}
 
 				// switch to output extension map
 				flow_record->map_ref = extension_info->exportMap ? extension_info->exportMap : extension_info->map;
diff --git a/bin/nfstat.c b/bin/nfstat.c
index 7a90e1cc..58aa1d6b 100644
--- a/bin/nfstat.c
+++ b/bin/nfstat.c
@@ -487,14 +487,6 @@ static uint64_t	flows_record(FlowTableRecord_t *record, int inout) {
 	return record->counter[FLOWS];
 }
 
-#define NeedSwap(GuessDir, r) ( GuessDir && \
-	((r)->prot == IPPROTO_TCP || (r)->prot == IPPROTO_UDP) && \
-	 ((((r)->srcport < 1024) && ((r)->dstport >= 1024)) || \
-	  (((r)->srcport < 32768) && ((r)->dstport >= 32768)) || \
-	  (((r)->srcport < 49152) && ((r)->dstport >= 49152)) \
-	 ) \
-	)
-
 static uint64_t	packets_record(FlowTableRecord_t *record, int inout) {
 	if (NeedSwap(GuessDirection, &(record->flowrecord))) {
 		if (inout == IN)
diff --git a/bin/nfstat.h b/bin/nfstat.h
index eac1f196..381198ef 100644
--- a/bin/nfstat.h
+++ b/bin/nfstat.h
@@ -104,6 +104,14 @@ typedef struct SortElement {
 #define MULTIPLE_LIST_ORDERS 1
 #define SINGLE_LIST_ORDER    0
 
+#define NeedSwap(GuessDir, r) ( GuessDir && \
+	((r)->prot == IPPROTO_TCP || (r)->prot == IPPROTO_UDP) && \
+	 ((((r)->srcport < 1024) && ((r)->dstport >= 1024)) || \
+	  (((r)->srcport < 32768) && ((r)->dstport >= 32768)) || \
+	  (((r)->srcport < 49152) && ((r)->dstport >= 49152)) \
+	 ) \
+	)
+
 /* Function prototypes */
 void SetLimits(int stat, char *packet_limit_string, char *byte_limit_string );
 
